#!/bin/bash
#%post appraiser
tomcat_dir="/usr/share/tomcat"
http_dir="/var/www/html"
apps_dir="$tomcat_dir/webapps"

echo "Making OAT Appraiser"

source /usr/share/oat-appraiser/oat_function
cur_dir="`pwd`"
cd $apps_dir
ln -sf /usr/share/oat-appraiser/webapps/HisWebServices .
ln -sf /usr/share/oat-appraiser/webapps/HisPrivacyCAWebServices2 .
ln -sf /usr/share/oat-appraiser/webapps/WLMService .
ln -sf /usr/share/oat-appraiser/webapps/AttestationService .

linkJar "$apps_dir/HisWebServices/WEB-INF/lib"
linkJar "$apps_dir/HisPrivacyCAWebServices2/WEB-INF/lib"
linkJar "$apps_dir/HisPrivacyCAWebServices2/ClientFiles/lib"
linkJar "$apps_dir/WLMService/WEB-INF/lib"
linkJar "$apps_dir/AttestationService/WEB-INF/lib"


#jar for tomcat
cd $tomcat_dir/lib
ln -sf /usr/share/java/commons-pool.jar .
ln -sf /usr/share/java/mysql-connector-java.jar .
cd $cur_dir

sed -i "s/<Listener className=\"org.apache.catalina.core.AprLifecycleListener\" SSLEngine=\"on\" \/>//g" $tomcat_dir/conf/server.xml

#delete_jars "$apps_dir/HisWebServices/WEB-INF/lib"
#delete_jars "$apps_dir/HisPrivacyCAWebServices2/WEB-INF/lib"
#delete_jars "$apps_dir/HisPrivacyCAWebServices2/ClientFiles/lib"
#delete_jars "$apps_dir/WLMService/WEB-INF/lib"
#delete_jars "$apps_dir/AttestationService/WEB-INF/lib"
#
#linkJar "$apps_dir/HisWebServices/WEB-INF/lib"
#linkJar "$apps_dir/HisPrivacyCAWebServices2/WEB-INF/lib"
#linkJar "$apps_dir/HisPrivacyCAWebServices2/ClientFiles/lib"
#linkJar "$apps_dir/WLMService/WEB-INF/lib"
#linkJar "$apps_dir/AttestationService/WEB-INF/lib"

#######Install script###########################################################
###Random generation /dev/urandom is good but just in case...
# Creating randoms for the p12 files and setting up truststore and keystore
ip12="internal.p12"
ipassfile="internal.pass"
idomfile="internal.domain"
iloc="/usr/share/oat-appraiser/"
p12file="$loc$ip12"
RAND1=$(dd if=/dev/urandom bs=1 count=1024)
RAND2=$(dd if=/dev/urandom bs=1 count=1024 | awk '{print $1}')
RAND3=$(dd if=/dev/urandom bs=1 count=1024 | awk '{print $1}')
randbits="$(echo "$( echo "`date +%N`" | md5sum | md5sum )$( echo "`dd if=/dev/urandom bs=1 count=1024`" | md5sum | md5sum)$(echo "`date +%N`" | md5sum | md5sum )$(echo "`dd if=/dev/urandom bs=1 count=1024 | awk '{print $1}'`" | md5sum | md5sum)$(echo "`date +%N`" | md5sum | md5sum)$(echo "`dd if=/dev/urandom bs=1 count=1024 | awk '{print $1}'`" | md5sum | md5sum)$(echo "`date +%N`" | md5sum | md5sum )" | md5sum | md5sum )"
randpass="${randbits:0:30}"
randbits2="$(echo "$( echo "`date +%N`" | md5sum | md5sum )$( echo "`dd if=/dev/urandom bs=1 count=1024`" | md5sum | md5sum)$(echo "`date +%N`" | md5sum | md5sum )$(echo "`dd if=/dev/urandom bs=1 count=1024 | awk '{print $1}'`" | md5sum | md5sum)$(echo "`date +%N`" | md5sum | md5sum)$(echo "`dd if=/dev/urandom bs=1 count=1024 | awk '{print $1}'`" | md5sum | md5sum)$(echo "`date +%N`" | md5sum | md5sum )" | md5sum | md5sum )"
randpass2="${randbits2:0:30}"
randbits3="$(echo "$( echo "`date +%N`" | md5sum | md5sum )$( echo "`dd if=/dev/urandom bs=1 count=1024`" | md5sum | md5sum)$(echo "`date +%N`" | md5sum | md5sum )$(echo "`dd if=/dev/urandom bs=1 count=1024 | awk '{print $1}'`" | md5sum | md5sum)$(echo "`date +%N`" | md5sum | md5sum)$(echo "`dd if=/dev/urandom bs=1 count=1024 | awk '{print $1}'`" | md5sum | md5sum)$(echo "`date +%N`" | md5sum | md5sum )" | md5sum | md5sum )"
randpass3="${randbits3:0:30}"
p12pass="$randpass"
mysqlPass="$randpass2"
keystore="keystore.jks"
truststore="TrustStore.jks"
if [ "`ls $iloc | grep $ip12`" ] && [ "`ls $iloc | grep $ipassfile`" ] ; then
  p12pass="`cat $loc$ipassfile`"
fi
if [ "`ls $iloc | grep $idomfile`" ] ; then
  domain="`cat $loc$idomfile`"
fi
#suport link jar with tomcat
sed -i "s/<Context>/<Context  allowLinking=\"true\">/g" $tomcat_dir/conf/context.xml

service tomcat stop
chkconfig network on
#chkconfig httpd on
chkconfig mysql on
#service httpd start
service mysql start

#Sets up database and user
#ISSKIPGRANTEXIT=`grep skip-grant-tables /etc/my.cnf`
#if [ ! "$ISSKIPGRANTEXIT" ]; then
#  sed -i 's/\[mysql\]/\[mysql\]\nskip-grant-tables/g' /etc/my.cnf
#fi

mysql -u root --execute="CREATE DATABASE oat_db; FLUSH PRIVILEGES; GRANT ALL ON oat_db.* TO 'oatAppraiser'@'localhost' IDENTIFIED BY '$randpass3';"


mysql -u root --execute="DROP DATABASE IF EXISTS oat_db;"
mysql -u root < /usr/share/oat-appraiser/oat_db.MySQL
mysql -u root < /usr/share/oat-appraiser/init.sql
#setting up access control in tomcat context.xml
sed -i "/<\/Context>/i\\   <Resource name=\"jdbc\/oat\" auth=\"Container\" type=\"javax.sql.DataSource\"  username=\"oatAppraiser\" password=\"$randpass3\" driverClassName=\"com.mysql.jdbc.Driver\"  factory=\"org.apache.commons.dbcp.BasicDataSourceFactory\"  url=\"jdbc:mysql:\/\/localhost:3306\/oat_db\"\/>" $tomcat_dir/conf/context.xml

#setting up port 8443 in tomcat server.xml
sed -i "s/<\/Service>/<Connector port=\"8443\" minSpareThreads=\"5\" maxSpareThreads=\"75\" enableLookups=\"false\" disableUploadTimeout=\"true\" acceptCount=\"100\" maxThreads=\"200\" scheme=\"https\" secure=\"true\" SSLEnabled=\"true\" clientAuth=\"want\" sslProtocol=\"TLS\" ciphers=\"TLS_ECDH_anon_WITH_AES_256_CBC_SHA, TLS_ECDH_anon_WITH_AES_128_CBC_SHA, TLS_ECDH_anon_WITH_3DES_EDE_CBC_SHA, TLS_ECDH_RSA_WITH_AES_256_CBC_SHA, TLS_ECDH_RSA_WITH_AES_128_CBC_SHA, TLS_ECDH_RSA_WITH_3DES_EDE_CBC_SHA, TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA, TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA, TLS_ECDHE_ECDSA_WITH_3DES_EDE_CBC_SHA, TLS_ECDH_ECDSA_WITH_AES_256_CBC_SHA, TLS_ECDH_ECDSA_WITH_AES_128_CBC_SHA, TLS_ECDH_ECDSA_WITH_3DES_EDE_CBC_SHA, TLS_DHE_RSA_WITH_AES_256_CBC_SHA, TLS_DHE_DSS_WITH_AES_256_CBC_SHA, TLS_RSA_WITH_AES_256_CBC_SHA, TLS_DHE_RSA_WITH_AES_128_CBC_SHA, TLS_DHE_DSS_WITH_AES_128_CBC_SHA, TLS_RSA_WITH_AES_128_CBC_SHA\" keystoreFile=\"\/var\/lib\/oat-appraiser\/Certificate\/keystore.jks\" keystorePass=\"$p12pass\" truststoreFile=\"\/var\/lib\/oat-appraiser\/Certificate\/TrustStore.jks\" truststorePass=\"password\" \/><\/Service>/g" $tomcat_dir/conf/server.xml

sed -i 's/<property name="connection.username">root<\/property>/<property name="connection.username">oatAppraiser<\/property>/' $tomcat_dir/webapps/HisWebServices/WEB-INF/classes/hibernateOat.cfg.xml
sed -i "s/<property name=\"connection.password\">oat-password<\/property>/<property name=\"connection.password\">$randpass3<\/property>/" $tomcat_dir/webapps/HisWebServices/WEB-INF/classes/hibernateOat.cfg.xml
sed -i "s/<server.domain>/$(hostname)/g" /etc/oat-appraiser/OpenAttestation.properties
sed -i "s/^truststore_path.*$/truststore_path=\/var\/lib\/oat-appraiser\/Certificate\/TrustStore.jks/g" /etc/oat-appraiser/OpenAttestation.properties
sed -i "s/^TrustStore.*$/TrustStore=\/var\/lib\/oat-appraiser\/Certificate\/TrustStore.jks/g"  /etc/oat-appraiser/OpenAttestation.properties

#OpenAttestationWebServices.properties
echo "default_attest_timeout=50000" > /etc/oat-appraiser/OpenAttestationWebServices.properties
echo "check_attest_interval=2000" >> /etc/oat-appraiser/OpenAttestationWebServices.properties

# Change owner to user 'tomcat'
chown -R tomcat /var/lib/oat-appraiser/ /var/lib/oat-appraiser/* /etc/oat-appraiser

#this code sets up the certificate attached to this computers hostname
cd /var/lib/oat-appraiser/Certificate/
echo "127.0.0.1       `hostname`" >> /etc/hosts
if [ "`echo $p12pass | grep $randpass`" ] ; then
  openssl req -x509 -nodes -days 730 -newkey rsa:2048 -keyout hostname.pem -out hostname.cer -subj "/C=US/O=U.S. Government/OU=DoD/CN=`hostname`"
  openssl pkcs12 -export -in hostname.cer -inkey hostname.pem -out $p12file -passout pass:$p12pass
fi

keytool -importkeystore -srckeystore $p12file -destkeystore $keystore -srcstoretype pkcs12 -srcstorepass $p12pass -deststoretype jks -deststorepass $p12pass -noprompt

myalias=`keytool -list -v -keystore $keystore -storepass $p12pass | grep -B2 'PrivateKeyEntry' | grep 'Alias name:'`

keytool -changealias -alias ${myalias#*:} -destalias tomcat -v -keystore $keystore -storepass $p12pass

rm -f $truststore
keytool -import -keystore $truststore -storepass password -file hostname.cer -noprompt

service tomcat start

sleep 20

service tomcat restart

#######################################################################
printf "appraisers installation ...done\n"
